// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: reclosermodule/reclosermodule.proto

package openfmb.reclosermodule;

/**
 * <pre>
 * Protection mode such as a group setting or pre-defined curve profile. It is usually pre-defined
 * by a circuit segment service.
 * </pre>
 *
 * Protobuf type {@code reclosermodule.RecloserDiscreteControlXCBR}
 */
public final class RecloserDiscreteControlXCBR extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:reclosermodule.RecloserDiscreteControlXCBR)
    RecloserDiscreteControlXCBROrBuilder {
private static final long serialVersionUID = 0L;
  // Use RecloserDiscreteControlXCBR.newBuilder() to construct.
  private RecloserDiscreteControlXCBR(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private RecloserDiscreteControlXCBR() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new RecloserDiscreteControlXCBR();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.reclosermodule.Reclosermodule.internal_static_reclosermodule_RecloserDiscreteControlXCBR_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.reclosermodule.Reclosermodule.internal_static_reclosermodule_RecloserDiscreteControlXCBR_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.reclosermodule.RecloserDiscreteControlXCBR.class, openfmb.reclosermodule.RecloserDiscreteControlXCBR.Builder.class);
  }

  public static final int DISCRETECONTROLXCBR_FIELD_NUMBER = 1;
  private openfmb.commonmodule.DiscreteControlXCBR discreteControlXCBR_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the discreteControlXCBR field is set.
   */
  @java.lang.Override
  public boolean hasDiscreteControlXCBR() {
    return discreteControlXCBR_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
   * @return The discreteControlXCBR.
   */
  @java.lang.Override
  public openfmb.commonmodule.DiscreteControlXCBR getDiscreteControlXCBR() {
    return discreteControlXCBR_ == null ? openfmb.commonmodule.DiscreteControlXCBR.getDefaultInstance() : discreteControlXCBR_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.DiscreteControlXCBROrBuilder getDiscreteControlXCBROrBuilder() {
    return discreteControlXCBR_ == null ? openfmb.commonmodule.DiscreteControlXCBR.getDefaultInstance() : discreteControlXCBR_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (discreteControlXCBR_ != null) {
      output.writeMessage(1, getDiscreteControlXCBR());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (discreteControlXCBR_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getDiscreteControlXCBR());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.reclosermodule.RecloserDiscreteControlXCBR)) {
      return super.equals(obj);
    }
    openfmb.reclosermodule.RecloserDiscreteControlXCBR other = (openfmb.reclosermodule.RecloserDiscreteControlXCBR) obj;

    if (hasDiscreteControlXCBR() != other.hasDiscreteControlXCBR()) return false;
    if (hasDiscreteControlXCBR()) {
      if (!getDiscreteControlXCBR()
          .equals(other.getDiscreteControlXCBR())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasDiscreteControlXCBR()) {
      hash = (37 * hash) + DISCRETECONTROLXCBR_FIELD_NUMBER;
      hash = (53 * hash) + getDiscreteControlXCBR().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.reclosermodule.RecloserDiscreteControlXCBR prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Protection mode such as a group setting or pre-defined curve profile. It is usually pre-defined
   * by a circuit segment service.
   * </pre>
   *
   * Protobuf type {@code reclosermodule.RecloserDiscreteControlXCBR}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:reclosermodule.RecloserDiscreteControlXCBR)
      openfmb.reclosermodule.RecloserDiscreteControlXCBROrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.reclosermodule.Reclosermodule.internal_static_reclosermodule_RecloserDiscreteControlXCBR_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.reclosermodule.Reclosermodule.internal_static_reclosermodule_RecloserDiscreteControlXCBR_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.reclosermodule.RecloserDiscreteControlXCBR.class, openfmb.reclosermodule.RecloserDiscreteControlXCBR.Builder.class);
    }

    // Construct using openfmb.reclosermodule.RecloserDiscreteControlXCBR.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      discreteControlXCBR_ = null;
      if (discreteControlXCBRBuilder_ != null) {
        discreteControlXCBRBuilder_.dispose();
        discreteControlXCBRBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.reclosermodule.Reclosermodule.internal_static_reclosermodule_RecloserDiscreteControlXCBR_descriptor;
    }

    @java.lang.Override
    public openfmb.reclosermodule.RecloserDiscreteControlXCBR getDefaultInstanceForType() {
      return openfmb.reclosermodule.RecloserDiscreteControlXCBR.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.reclosermodule.RecloserDiscreteControlXCBR build() {
      openfmb.reclosermodule.RecloserDiscreteControlXCBR result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.reclosermodule.RecloserDiscreteControlXCBR buildPartial() {
      openfmb.reclosermodule.RecloserDiscreteControlXCBR result = new openfmb.reclosermodule.RecloserDiscreteControlXCBR(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.reclosermodule.RecloserDiscreteControlXCBR result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.discreteControlXCBR_ = discreteControlXCBRBuilder_ == null
            ? discreteControlXCBR_
            : discreteControlXCBRBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.reclosermodule.RecloserDiscreteControlXCBR) {
        return mergeFrom((openfmb.reclosermodule.RecloserDiscreteControlXCBR)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.reclosermodule.RecloserDiscreteControlXCBR other) {
      if (other == openfmb.reclosermodule.RecloserDiscreteControlXCBR.getDefaultInstance()) return this;
      if (other.hasDiscreteControlXCBR()) {
        mergeDiscreteControlXCBR(other.getDiscreteControlXCBR());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getDiscreteControlXCBRFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.DiscreteControlXCBR discreteControlXCBR_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.DiscreteControlXCBR, openfmb.commonmodule.DiscreteControlXCBR.Builder, openfmb.commonmodule.DiscreteControlXCBROrBuilder> discreteControlXCBRBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the discreteControlXCBR field is set.
     */
    public boolean hasDiscreteControlXCBR() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     * @return The discreteControlXCBR.
     */
    public openfmb.commonmodule.DiscreteControlXCBR getDiscreteControlXCBR() {
      if (discreteControlXCBRBuilder_ == null) {
        return discreteControlXCBR_ == null ? openfmb.commonmodule.DiscreteControlXCBR.getDefaultInstance() : discreteControlXCBR_;
      } else {
        return discreteControlXCBRBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setDiscreteControlXCBR(openfmb.commonmodule.DiscreteControlXCBR value) {
      if (discreteControlXCBRBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        discreteControlXCBR_ = value;
      } else {
        discreteControlXCBRBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setDiscreteControlXCBR(
        openfmb.commonmodule.DiscreteControlXCBR.Builder builderForValue) {
      if (discreteControlXCBRBuilder_ == null) {
        discreteControlXCBR_ = builderForValue.build();
      } else {
        discreteControlXCBRBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeDiscreteControlXCBR(openfmb.commonmodule.DiscreteControlXCBR value) {
      if (discreteControlXCBRBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          discreteControlXCBR_ != null &&
          discreteControlXCBR_ != openfmb.commonmodule.DiscreteControlXCBR.getDefaultInstance()) {
          getDiscreteControlXCBRBuilder().mergeFrom(value);
        } else {
          discreteControlXCBR_ = value;
        }
      } else {
        discreteControlXCBRBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearDiscreteControlXCBR() {
      bitField0_ = (bitField0_ & ~0x00000001);
      discreteControlXCBR_ = null;
      if (discreteControlXCBRBuilder_ != null) {
        discreteControlXCBRBuilder_.dispose();
        discreteControlXCBRBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.DiscreteControlXCBR.Builder getDiscreteControlXCBRBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getDiscreteControlXCBRFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.DiscreteControlXCBROrBuilder getDiscreteControlXCBROrBuilder() {
      if (discreteControlXCBRBuilder_ != null) {
        return discreteControlXCBRBuilder_.getMessageOrBuilder();
      } else {
        return discreteControlXCBR_ == null ?
            openfmb.commonmodule.DiscreteControlXCBR.getDefaultInstance() : discreteControlXCBR_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.DiscreteControlXCBR discreteControlXCBR = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.DiscreteControlXCBR, openfmb.commonmodule.DiscreteControlXCBR.Builder, openfmb.commonmodule.DiscreteControlXCBROrBuilder> 
        getDiscreteControlXCBRFieldBuilder() {
      if (discreteControlXCBRBuilder_ == null) {
        discreteControlXCBRBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.DiscreteControlXCBR, openfmb.commonmodule.DiscreteControlXCBR.Builder, openfmb.commonmodule.DiscreteControlXCBROrBuilder>(
                getDiscreteControlXCBR(),
                getParentForChildren(),
                isClean());
        discreteControlXCBR_ = null;
      }
      return discreteControlXCBRBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:reclosermodule.RecloserDiscreteControlXCBR)
  }

  // @@protoc_insertion_point(class_scope:reclosermodule.RecloserDiscreteControlXCBR)
  private static final openfmb.reclosermodule.RecloserDiscreteControlXCBR DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.reclosermodule.RecloserDiscreteControlXCBR();
  }

  public static openfmb.reclosermodule.RecloserDiscreteControlXCBR getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<RecloserDiscreteControlXCBR>
      PARSER = new com.google.protobuf.AbstractParser<RecloserDiscreteControlXCBR>() {
    @java.lang.Override
    public RecloserDiscreteControlXCBR parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<RecloserDiscreteControlXCBR> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<RecloserDiscreteControlXCBR> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.reclosermodule.RecloserDiscreteControlXCBR getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

